--[[
Copyright 2016 MoikMellah

This file is part of the NoName sample module for use with the SYPHA Engine.

The NoName module is free software: you can redistribute it and/or modify it under the terms
of the CC-By-SA 4.0 license as published by Creative Commons.

This code is provided strictly as-in and WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the included file 'LICENSE.CC-BY-SA.txt' for full details.

You should have received a copy of the CC-By-SA 4.0 License along with
the NoName module. If not, see https://creativecommons.org/licenses/by-sa/4.0/
]]--
--[[
function Actor:equipmentUiNav(s_btn)

	local btn = s_btn or 'right'
	
	local nbtn = string.sub(btn,1,1)

	self.vars.posId = self.vars.posId or 1
	local op = self.vars.pos[self.vars.posId] or {}
	self.vars.posId = op[nbtn] or self.vars.posId
	local np = self.vars.pos[self.vars.posId]
	self.prim[1].x = np.x
	self.prim[1].y = np.y
	self.prim[1].w = np.w or 1
	self.prim[1].h = np.h or 1

end
]]--
function Actor:linkGuiElements()

	local guiQuery = Queryable.new(self.scene.vars.guiArray)
	
	for k,v in ipairs(self.scene.vars.guiArray) do
		local x = v.x
		local y = v.y
		
		local downElement = guiQuery:Where('x => x.y > '..y):OrderBy('x => dist(x.x, x.y, '..x..', '..y..')'):First()
		if(downElement) then v.d = downElement.invPos end

		local upElement = guiQuery:Where('x => x.y < '..y):OrderBy('x => dist(x.x, x.y, '..x..', '..y..')'):First()
		if(upElement) then v.u = upElement.invPos end
		
		local leftElement = guiQuery:Where('x => x.x < '..x):OrderBy('x => dist(x.x, x.y, '..x..', '..y..')'):First()
		if(leftElement) then v.l = leftElement.invPos end

		local rightElement = guiQuery:Where('x => x.x > '..x):OrderBy('x => dist(x.x, x.y, '..x..', '..y..')'):First()
		if(rightElement) then v.r = rightElement.invPos end
	end
end

function Scene:setupInventoryGui()
	self.vars.sourceActor = self.env.vars.hero
	self.vars.guiArray = self.vars.guiArray or {}
	--[[
	for i = 1,64 do
		local j = i-1
		local thing = self:spawn('invIcon', 2+(1.5*math.floor(j/4)), 2+(1.5*math.floor(j%4)), 0)
		thing.invPos = i
		self.vars.guiArray[i] = thing
	end
	]]--
	
	-- Action slots
	for i = 1,3 do
		local j = i-1
		local thing = self:spawn('invIcon', 5+(1.5*j), 3.5, 0)
		thing.invPos = i
		thing.slot = 'act'
		self.vars.guiArray[i] = thing
	end
	
	-- Equipment slots
	for i = 4,9 do
		local j = i-4
		local thing = self:spawn('invIcon', 15+(1.5*j), 3.5, 0)
		thing.invPos = i
		self.vars.guiArray[i] = thing
	end
	self.vars.guiArray[4].slot = 'shield'
	self.vars.guiArray[5].slot = 'armor'
	self.vars.guiArray[6].slot = 'helm'
	self.vars.guiArray[7].slot = 'boot'
	self.vars.guiArray[8].slot = 'accessory'
	self.vars.guiArray[9].slot = 'accessory'
	
	-- Ammo slots
	for i = 10,13 do
		local j = i-10
		local thing = self:spawn('invIcon', 2, 7.5+(1.5*j), 0)
		thing.invPos = i
		thing.slot = 'ammo'
		self.vars.guiArray[i] = thing
	end
	
	-- Inventory slots
	for i = 14,61 do
		local j = i-14
		local ix = 5+(1.5*math.floor(j/4))
		local iy = 7.5+(1.5*math.floor(j%4))
		local thing = self:spawn('invIcon', ix,iy, 0)
		thing.invPos = i
		thing.slot = 'inv'
		self.vars.guiArray[i] = thing
	end
	
	-- Other elements
	
	-- Cursor obj
	local curs = self:spawn('invCursor',0,0)
	curs:linkGuiElements()
	
	--Cleanup
	for i = 1,61 do
		self.vars.guiArray[i]:setSingleInvIcon()
	end
end
